// Sugarscape in Swarm. Copyright (C) 1997 Nelson Minar
// This program is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import <swarmobject.h>
#import <simtools/GUISwarm.h>
#import <analysis.h>
#import "ModelSwarm.h"

// The observer swarm contains all the objects used to instrument a model
@interface ObserverSwarm : GUISwarm {
  ModelSwarm * modelSwarm;			  // the model being run

  char * parameterFile;
  int displayFrequency;				  // how often to update
  int drawPopulationGraph;			  // flag
  int drawWealthHistogram;			  // flag

  XColormap * colormap;				  // colours
  ZoomRaster * worldRaster;			  // window on world
  Value2dDisplay * sugarDisplay;		  // sugar displayer
  Object2dDisplay * agentDisplay;		  // agent displayer
  EZGraph * populationGraph;			  // population graph
  EZGraph * attributeGraph;			  // agent attributes graph
  EZBin * wealthHistogram;			  // histogram of wealth

  id displayActions;				  // schedule objects
  id displaySchedule;
}

+createBegin: (id) aZone;
-buildObjects;
-buildActions;
-activateIn: (id) swarmContext;

@end
